import { defineComponent, $prefix, props, setup } from '@opentinyvue/vue-common';
import { renderless, api } from '@opentinyvue/vue-renderless/fluent-editor/vue';
import '@opentinyvue/vue-theme/fluent-editor/index.css';
import FluentEditor from '@opentiny/fluent-editor';
import '@opentiny/fluent-editor/style.css';
import { IconEditorAlignCenter, IconEditorAlignLeft, IconEditorAlignRight, IconEditorBackground, IconEditorBold, IconEditorCode, IconEditorDeleteline, IconEditorEraser, IconEditorItalic, IconEditorLeftBorder, IconEditorList, IconEditorListDot, IconEditorListNum, IconEditorMenuLeft, IconEditorMenuRight, IconEditorQuote, IconEditorRedo, IconEditorRightBorder, IconEditorSub, IconEditorSubtitle, IconEditorSuper, IconEditorTable, IconEditorTextcolor, IconEditorTitle, IconEditorUnderline, IconEditorUndo, IconEditorVideo, IconLink, IconPicture, IconCloudUpload, IconFullscreen } from '@opentinyvue/vue-icon';
import ImageViewer from '@opentinyvue/vue-image-viewer';

function normalizeComponent(scriptExports, render, staticRenderFns, functionalTemplate, injectStyles, scopeId, moduleIdentifier, shadowMode) {
  var options = typeof scriptExports === "function" ? scriptExports.options : scriptExports;
  if (render) {
    options.render = render;
    options.staticRenderFns = staticRenderFns;
    options._compiled = true;
  }
  var hook;
  if (injectStyles) {
    hook = injectStyles;
  }
  if (hook) {
    if (options.functional) {
      options._injectStyles = hook;
      var originalRender = options.render;
      options.render = function renderWithStyleInjection(h, context) {
        hook.call(context);
        return originalRender(h, context);
      };
    } else {
      var existing = options.beforeCreate;
      options.beforeCreate = existing ? [].concat(existing, hook) : [hook];
    }
  }
  return {
    exports: scriptExports,
    options
  };
}

var __vue2_script = defineComponent({
  name: $prefix + "FluentEditor",
  components: {
    TinyImageViewer: ImageViewer,
    IconEditorAlignCenter: IconEditorAlignCenter(),
    IconEditorAlignLeft: IconEditorAlignLeft(),
    IconEditorAlignRight: IconEditorAlignRight(),
    IconEditorBackground: IconEditorBackground(),
    IconEditorBold: IconEditorBold(),
    IconEditorCode: IconEditorCode(),
    IconEditorDeleteline: IconEditorDeleteline(),
    IconEditorEraser: IconEditorEraser(),
    IconEditorItalic: IconEditorItalic(),
    IconEditorLeftBorder: IconEditorLeftBorder(),
    IconEditorList: IconEditorList(),
    IconEditorListDot: IconEditorListDot(),
    IconEditorListNum: IconEditorListNum(),
    IconEditorMenuLeft: IconEditorMenuLeft(),
    IconEditorMenuRight: IconEditorMenuRight(),
    IconEditorQuote: IconEditorQuote(),
    IconEditorRedo: IconEditorRedo(),
    IconEditorRightBorder: IconEditorRightBorder(),
    IconEditorSub: IconEditorSub(),
    IconEditorSubtitle: IconEditorSubtitle(),
    IconEditorSuper: IconEditorSuper(),
    IconEditorTable: IconEditorTable(),
    IconEditorTextcolor: IconEditorTextcolor(),
    IconEditorTitle: IconEditorTitle(),
    IconEditorUnderline: IconEditorUnderline(),
    IconEditorUndo: IconEditorUndo(),
    IconEditorVideo: IconEditorVideo(),
    IconLink: IconLink(),
    IconPicture: IconPicture(),
    IconCloudUpload: IconCloudUpload(),
    IconFullscreen: IconFullscreen()
  },
  emits: ["ready", "blur", "focus", "update:modelValue", "change"],
  props: [].concat(props, ["_constants", "content", "disabled", "fileUpload", "globalOptions", "imageUpload", "mentionObj", "modelValue", "options", "picPreview", "dataType", "dataUpgrade", "zIndex", "imagePasteFailCallback", "beforeEditorInit"]),
  setup: function setup$1(props2, context) {
    return setup({
      props: props2,
      context,
      renderless,
      api,
      extendOptions: {
        FluentEditor
      }
    });
  }
});
var render = function render2() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("div", {
    staticClass: "tiny-editor-wrapper",
    class: {
      "fullscreen": _vm.state.isFullscreen
    },
    style: {
      "z-index": _vm.state.zIndex
    }
  }, [_c("div", {
    ref: "editor",
    staticClass: "tiny-editor",
    attrs: {
      "id": "editor"
    },
    on: {
      "dblclick": _vm.handleDblclick
    }
  }), _vm.state.showPreview ? _c("tiny-image-viewer", _vm._b({}, "tiny-image-viewer", _vm.state.previewOptions, false)) : _vm._e(), _c("div", {
    ref: "editor-toolbar-icon",
    staticClass: "toolbar-icon"
  }, _vm._l(_vm.state.icons, function(icon) {
    return _c("div", {
      key: icon,
      ref: icon,
      refInFor: true
    }, [_c(icon, {
      tag: "component"
    })], 1);
  }), 0)], 1);
};
var staticRenderFns = [];
var __cssModules = {};
var __component__ = /* @__PURE__ */ normalizeComponent(__vue2_script, render, staticRenderFns, false, __vue2_injectStyles);
function __vue2_injectStyles(context) {
  for (var o in __cssModules) {
    this[o] = __cssModules[o];
  }
}
var pc = /* @__PURE__ */ function() {
  return __component__.exports;
}();

export { pc as default };
